/* This is an POV-Ray include file used by AERO. Here, all materials used in
   a raytracer sequence created by AERO must be declared. */

#declare aeroiron =
texture
{
    ambient 0.3
    metallic
    color red 1 green 1 blue 1 alpha 0
    diffuse 0.6
    brilliance 5.0  /* war 7.0 */
    specular 1.0
    roughness 0.01
}

#declare aeroplastic =
texture
{
    ambient 0.15
    diffuse 0.6
    specular 1.0
    roughness 0.05
    brilliance 1.0
}

#declare aerocork =
texture
{
    granite
    turbulence 0
    specular 0.1
    color_map
    {
	[0.0 0.4  color red 0 green 0 blue 0 alpha 0.0
                  color red 0 green 0 blue 0 alpha 0.0]
	[0.4 0.45 color red 0.85 green 0.85 blue 0.95 alpha 0.0
		  color red 0.85 green 0.85 blue 0.95 alpha 0.0]
	[0.45 0.5 color red 0.85 green 0.85 blue 0.95 alpha 0.0
	          color red 0.752941 green 0.752941 blue 0.752941 alpha 0.0]
	[0.5 0.55 color red 0.752941 green 0.752941 blue 0.752941 alpha 0.0
		  color red 0.82 green 0.57 blue 0.46 alpha 0.0]
        [0.55 0.9 color red 0.82 green 0.57 blue 0.46 alpha 0.0
		  color red 0.82 green 0.57 blue 0.46 alpha 0.0]
	[0.9 1.0  color red 1.0 green 1.0 blue 1.0 alpha 0.0
		  color red 1.0 green 1.0 blue 1.0 alpha 0.0]
    }			/* Default-Transparency 45% */
			/* Default-Roughness: 50% */
			/* Default-Reflection 0% */
    scale <0.12 0.12 0.12>
}

#declare aeroice =
texture
{
    
}

#declare aeroglass =
texture
{
    specular 1.0
    roughness 0.001
    ambient 0.15
    color red 1.0 green 1.0 blue 1.0 alpha 0.8
    diffuse 0.0
    reflection 0.1
    refraction 1.0
    ior   1.001
}                    /* Default-Transparency 90% */

#declare aerogranite =
texture
{
   granite
   turbulence 0
   color_map {
      [0.0 0.4 	color red 0.0 green 0.0 blue 0.0 
		color red 0.0 green 0.0 blue 0.0]
      [0.4 0.45 color red 0.85 green 0.85 blue 0.95 
		color red 0.85 green 0.85 blue 0.95]
      [0.45 0.5 color red 0.85 green 0.85 blue 0.95 
		color red 0.752941 green 0.752941 blue 0.752941]
      [0.5 0.55 color red 0.752941 green 0.752941 blue 0.752941
		color red 0.82 green 0.57 blue 0.46]
      [0.55 0.8 color red 0.82 green 0.57 blue 0.46 
		color red 0.82 green 0.57 blue 0.46]
      [0.8 1.0 	color red 0.82 green 0.57 blue 0.46 
		color red 1 green 0.5 blue 0.0]
   }
}

#declare aerogold =
texture
{
   color red 0.8 green 0.498039 blue 0.196078
   metallic
   ambient 0.2
   diffuse 0.7
   brilliance 6.0
   reflection 0.25
   phong 0.75
   phong_size 80
}  	/* default color: red 0.8 green 0.498039 blue 0.196078 */
	/* default transparency: 80% */
	/* default reflection: 25% */
	/* default roughness: 0% */


#declare aeroalu =
texture
{
    ambient .15
    
}

#declare aerowood =
texture
{
    color red 0.593744 green 0.374975 blue 0.0 alpha 0.0
    ambient .15
    wood
/*    color_map
    {
	[0.0 0.8  color red 0.593744 green 0.374975 blue 0.0 alpha 0.0
                  color red 0.593744 green 0.374975 blue 0.0 alpha 0.0]
	[0.8 1.0  color red 0.1187488 green 0.074995 blue 0.0 alpha 0.0
		  colour red 0.0 green 0.0 blue 0.0 alpha 0.0]
    }
*/
    color_map
    {
	[0.0 0.8  color red 1 green 1 blue 1 alpha 0.0
                  color red 1 green 1 blue 1 alpha 0.0]
	[0.8 1.0  color red 0.1 green 0.1 blue 0.1 alpha 0.0
		  colour red 0.0 green 0.0 blue 0.0 alpha 0.0]
    }			/* Default-Transparency 35% */

    turbulence .04
    rotate <0 0 70>
    rotate <0 20 0>
    scale <.01 .03 .01>
    translate <0 3 0>
}

#declare aeroconcrete =
texture
{
	granite
	color_map
	{
	   [ 0.0 0.25 color red 0.1 green 0.1 blue 0.1
		     color red 0.5 green 0.53 blue 0.57 ]
	   [ 0.25 1.0 color red 0.5 green 0.53 blue 0.57
		     color red 0.5 green 0.53 blue 0.57 ]
	}
	scale <0.03 0.03 0.03>
	ambient 0.1
	reflection 0.0
	specular 0.1
	roughness 0.8
}	/* Default-Transparency: 50% */
	/* Default-Reflection: 0% */
	/* Default Roughness: 80% */

#declare aerobrick =
texture
{
	granite
	color_map
	{
	   [ 0.0 0.15 color red 0.0 green 0.0 blue 0.0
		     color red 0.2 green 0.04 blue 0.0 ]
	   [ 0.15 1.0 color red 1.0 green 0.2 blue 0.02353
		     color red 1.0 green 0.2 blue 0.02353 ]
	}
	scale <0.1 0.1 0.1>
	ambient 0.1
	diffuse 0.7
	reflection 0.0
	specular 0.1
	roughness 0.8
}  	/* default color: red 1.0 green 0.2 blue 0.02353 */
	/* default transparency: 50% */
	/* default reflection: 0% */
	/* default roughness: 80% */


#declare aerorubber =
texture
{
	ambient 0.15
	diffuse 0.7
}	/* default roughness: 60% */
	/* default transparency: 30% */
        /* default reflection: 0% */

