/********************************************************************************
 *  Projektname:	AERO
 *  Filename:		Kamera.h
 *  Filetyp:		Definition
 ********************************************************************************
 *  Modulname:		Kamera.h
 *  Version:		1.1
 *  letzte Aenderung:	08.02.93
 *  Autor:  		Andreas
 *  Status:		Fertig
 *							
 *  exp. Bezeichner:    TKamera
 *
 *  Beschreibung:
 *  -------------
 *     In diesem Modul wird eine Struktur TKamera definiert, die alle zur
 *     Repr"asentation einer Kamera notwendigen Daten enth"alt.
 *
 *  Versionsgeschichte:
 *  -------------------
 *   08.02.93: Definition der Datenstruktur TKamera wurde aus dem Definitions-
 *             modul Welt.h ausgegliedert, so da"s Hartmut beim dazubinden der
 *             Kamera-Definition nicht s"amtliche Datenstrukturen, die er f"ur
 *             seine Animation nicht bracht mit dazugelinkt werden.
 *  -24.06.93: Kameradaten wurden um notwendige Daten f"ur das montieren auf 
 *             einem K"orper erweitert.
 ********************************************************************************/

#ifndef KAMERA_H
#define KAMERA_H

#ifndef GRUNDTYPEN_H
#include "grundtypen.h"
#endif

#ifndef KOERPER_H
#include "koerper.h"
#endif


typedef struct TKamera {
           TVektor      Position;
           TQuaternion  Richtung;
	   TReal        Zoom;
	   TVektor      Offset;
	   TKoerper     *MountObj;
	   long         MountObjId;
        } TKamera;

#endif



