/********************************************************************************
 *  Projektname		: AERO
 *  Filename		: anzeigeconst.h
 *  Filetyp		: Header
 ********************************************************************************
 *  Modulname		: -
 *  Version           	: 0
 *  letzte Aenderung	: 16.2.93
 *  Autor		: Hartmut
 *  
 *  Beschreibung:
 *  Definition einiger Konstanten, mit denen relativ einfach die Bits der
 *  von mir verwendeten Bitvektoren beeinflusst werden koennen.
 *  Es gibt immer 2 Versionen: die ...ON-Version muss verODERt werden und
 *  setzt das entsprechende Bit, die ...OFF-Version muss verUNDet werden und
 *  loescht das Bit.
 *  
 *  Exportierte Funktionen/Makros:
 * 
 *  Noch zu machen:
 *
 *  Versionsgeschichte:
 *  
 ********************************************************************************/


/* 
 * Masken zum Setzen der AStatus-Bits im Typ TKoerper und TVerbindung:
 */

#define SelectedON     (1<<0)
#define SelectedOFF    (~SelectedON)
#define HiddenON       (1<<1)
#define HiddenOFF      (~HiddenON)


/*
 * Masken zum Setzen des Modus bei den Anzeige...()-Routinen:
 */

#define FloorON        (1<<0)
#define FloorOFF       (~FloorON)
#define WindowCoordON  (1<<1)
#define WindowCoordOFF (~WindowCoordON)
#define ObjectCoordON  (1<<2)
#define ObjectCoordOFF (~ObjectCoordON)
#define ForcesON       (1<<3)
#define ForcesOFF      (~ForcesON)
#define Show3dON       (1<<4)
#define Show3dOFF      (~Show3dON)



