/********************************************************************************
 *  Projektname		: AERO
 *  Filename		: ausgabe.h
 *  Filetyp		: Headerfile
 ********************************************************************************
 *  Modulname		: ausgabe.o
 *  letzte Aenderung	: Donnerstag, 29. August 1996, 17:08:40
 *  Autor		: Horst Stolz (HUS)
 *  Status:		: ungetestetes Dummy-File
 *  
 *  Beschreibung:
 *    Liefert primitive Routinen um einen Zustand, Koerper, Kollisions,
 *    Verbindung, usw. als Text auszugeben.
 *    Und zwar zu Test und Debugging-Zwecken.
 *    Die Ausgabe erfolgt deswegen in den Fehlerkanal.
 * 
 ********************************************************************************/
#ifndef AUSGABE_H
#define AUSGABE_H

#ifndef GRUNDTYPEN_H
#include "grundtypen.h"
#endif

#ifndef KOLLISION_H
#include "kollision.h"
#endif

extern void printvektor(char *s, TVektor v);
extern void printmatrix(char *s, TMatrix m);
extern void printeulerpar(char *s, TQuaternion q);
extern void printkollision(TKollision *kh);
extern void printkolliste(TKollision *k);
extern void printkoerper(TKoerper *k);
extern void printkoeliste(TKoerper *k);
extern void printverbindung(TVerbindung *v);
extern void printverbliste(TVerbindung *v);
extern void printzustand(TZustand *z); 

#endif
